<?php

declare(strict_types=1);

namespace Dedi\SyliusQuotePlugin\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * @ORM\Entity
 *
 * @ORM\Table(name="dedi_sylius_quote_plugin_quote_item_information")
 */
class QuoteItemInformation implements QuoteItemInformationInterface
{
    /**
     * @ORM\Id
     *
     * @ORM\Column(type="integer")
     *
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    protected ?int $id = null;

    /**
     * @ORM\OneToOne(targetEntity="Sylius\Component\Order\Model\OrderItemInterface", inversedBy="quoteItemInformation", cascade={"persist", "remove"})
     *
     * @ORM\JoinColumn(name="order_item_id", referencedColumnName="id", nullable=false)
     */
    protected OrderItemInterface $orderItem;

    /** @ORM\Column(name="unit_price", type="integer", nullable="true", options={"default": null}) */
    protected ?int $unitPrice = null;

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getOrderItem(): OrderItemInterface
    {
        return $this->orderItem;
    }

    public function setOrderItem(OrderItemInterface $orderItem): self
    {
        $this->orderItem = $orderItem;

        return $this;
    }

    public function getUnitPrice(): ?int
    {
        return $this->unitPrice;
    }

    public function setUnitPrice(?int $unitPrice): self
    {
        $this->unitPrice = $unitPrice;

        return $this;
    }

    public function getTotal(): ?int
    {
        return $this->unitPrice * $this->orderItem->getQuantity();
    }
}
